/*
001     it works!
002     added function drawMenuItem
003     cleaning up
004     bugfixing bouncing keys and problems with everdrive + cleaning up and commenting
        selector sometimes did not show - problem with VDP code?
005     cleaning up
006     release
007     bugfix
008     bugfix
009     bugfix
010     revising and optimizing
011     trying to fix menu skipping issue. I revise back to version 5
012     working - but older - version. Optimizing a bit, trying not to break things.
013     fixing more...
014     fixing more - seems like everdrive needs file to be power of two..
--------------------------------------------------
TRAINERS: DO IT YOURSELF
- The .asm source for a trainer patch for Altered Beast
                By hang-on, at the SMS-Power forum 2013
*/

; WLA-DX ----------------------------------------------------------------------
.MEMORYMAP
SLOTSIZE $4000
defaultslot 2
SLOT 0 $0000
SLOT 1 $4000
SLOT 2 $8000
.ENDME
.ROMBANKMAP
BANKSTOTAL 32
BANKSIZE $4000
BANKS 32
.ENDRO

.background "altbeast_512.sms"
;------------------------------------------------------------------------------


; Variables -------------------------------------------------------------------
.DEFINE vPlayerState           $C24C
.DEFINE vPageNumber            $DF90
.DEFINE vLevel                 $C08D
;------------------------------------------------------------------------------

; Definitions -----------------------------------------------------------------
.DEFINE dWerebeast             $02
.DEFINE dTransformControl      $C220
.DEFINE dVDPCommand            $bf
.DEFINE dVDPData               $be
.DEFINE dBlackTile             $00
.DEFINE dDotTile               $BF
.DEFINE dVDPReg1               $81
.DEFINE dP1Up                  $01
.DEFINE dP1Down                $02
.DEFINE dP1Button1             $10
.DEFINE dP1Button2             $20
.DEFINE dPortJoystick          $dc
;------------------------------------------------------------------------------


.orga $0066                                         ; the pause handler (always at $0066)
      call       powerUp                            ; press pause to power up
      retn                                          ; return from pause handler


.orga $030B                                         ; disable demos
      .DB        $00 $00

.orga $0320                                         ; originally a space for handling demos
powerUp:                                            ; with demos disabled, I can use this space for my power
                                                    ; up function
      push       af
      ld         a,(vPlayerState)                   ; check if player is already fully powered up
      cp         dWerebeast                         ; = he is a werebeast
      jr         z,+                                ; if so, then jump out
      ld         a,$01                              ; else put $01 into a designated area to begin transformation
      ld         (dTransformControl), a             ; this I learned from a PAR code listing for Altered Beast
+:
      pop        af
      ret


.orga $032F                                         ; originally a space for handling demos
customHandler:                                      ; new use: Jump to the appended space (the level selector)


      ld         a,($FFFF)                          ; read current page number
      ld         (vPageNumber),a                    ; and save it in unused RAM (near the stack)

      ld         a,:levelSelector
      ld         ($FFFF),a                          ; activate the page of the appended space

      call       levelSelector                      ; call function to handle level selector menu

      ld         a,(vPageNumber)                    ; retrieve saved page number
      ld         ($FFFF),a                          ; and activate it
      ret                                           ; return to original program code loading chosen level


.orga $0451                                         ; about to transition from title screen to level
      call       customHandler

.orga $0C80
      .DB        $00 $00                            ; overwrites SUB 01h (D6 01) with 00's
                                                    ; so that lives are not decremented

.orga $1016                                         ; this patch alters Zeus' command at the start of the game

      .DB        $a4 $ac $a5 $aa $fe $98 $a4        ; "RISE FROM YOUR GRAVE"
      .DB        $a1 $9f $fe $9a $a1 $a7 $a4
      .DB        $fe $99 $a4 $93 $a8 $aa

      .DB        $fe $fe $fe $fe $fe $fe $fe        ; fill-in invisible spaces
      .DB        $fe $fe $fe $fe

      .DB        $a2 $a4 $aa $a5 $a5 $fe $a2        ; "PRESS PAUSE TO POWER UP"
      .DB        $93 $a7 $a5 $aa $fe $a6 $a1
      .DB        $fe $a2 $a1 $95 $aa $a4 $fe
      .DB        $a7 $a2

      .DB        $fe $fe $fe $fe $fe                ; fill-in invisible spaces


.bank 1
.slot 1
.orga $69EB                                         ; this patch causes the word "x TRAINER x"
                                                    ; to be flashing from the title screen

      .DB        $00 $00 $00 $ba $00                ; spaces and an x
      .DB        $a6 $a4 $93 $ac $a0 $aa $a4        ; "TRAINER"
      .DB        $00 $ba $00 $00 $00                ; spaces and an x



; ===========================================================================;
;                                                                            ;
;                 ***** SELECT LEVEL MENU *****                              ;
;                                                                            ;
; ===========================================================================;


.bank 17
.orga $8000
levelSelector:

      ld         hl,$C062                           ; clean up RAM (code from original ROM)
      ld         de,$C063                           ; it is important to modify the RAM (level, energy, lives, etc.)
      ld         bc,$078B                           ; AFTER this cleaning has taken place
      ld         (hl),$00
      ldir

      di                                            ; safety first
      push       af                                 ; minimizing the impact on the original program flow
      push       bc
      push       de
      push       hl

drawBox:                                            ; draw a black box for the level selector menu
      ld         hl,$3944                           ; start position on tilemap
      ld         c,14                               ; 14 rows of black tiles

drawRow:                                            ; draws a row of black tiles (29 tiles pr. row)
      push       hl                                 ; save start position
      push       bc                                 ; save current row

      ld         a,h                                ; set up VDP for writing to the tilemap
      or         $40                                ; refer to SEGA Software Developers Reference
      ld         h,a
      ld         a,l
      out        (dVDPCommand),a
      ld         a,h
      out        (dVDPCommand),a

      ld         a,dBlackTile                     ; write tile $00 (black) with no attribs set
      ld         b,58                              ; write 29 tiles = 58 bytes because each tile is a word
-:
      out        (dVDPData),a                     ; write one byte to video RAM
      dec        b
      jp         nz,-                               ; check to see if we have done all 29 tiles (58 bytes)

      pop        bc                                 ; get the row counter back
      pop        hl                                 ; and the start position on tilemap

      dec        c                                  ; one row down...
      jp         z,write_menu                       ; ... if this was all 14 rows, jump out
                                                    ; to write the characters in the menu

      ld         de,$40                             ; else add $40 to the tilemap start position
      add        hl,de                              ; (point to the next row below)

      jp         drawRow                            ; do everything once more (draw one more row)


write_menu:

      ld         hl,$39D4
      ld         de,menuTitle                       ; write menu title (SELECT LEVEL)
      ld         b,menuTitleEnd-menuTitle
      call       drawMenuItem

      ld         hl,$3A8C
      ld         de,menuitemGraveyard               ; write first menu item (GRAVEYARD):
      ld         b,menuitemGraveyardEnd-menuitemGraveyard
      call       drawMenuItem

      ld         hl,$3B0C
      ld         de,menuitemUnderworld              ; write second menu item (UNDERWORLD):
      ld         b,menuitemUnderworldEnd-menuitemUnderworld
      call       drawMenuItem

      ld         hl,$3B8C
      ld         de,menuitemNeff                    ; write third menu item (NEFFS PALACE):
      ld         b,menuitemNeffEnd-menuitemNeff
      call       drawMenuItem

      ld         hl,$3C0C
      ld         de,menuitemDis                     ; write fourth menu item (THE CITY OF DIS):
      ld         b,menuitemDisEnd-menuitemDis
      call       drawMenuItem


      ld         hl,$3A8A
      ld         d,dDotTile                         ; draw dot tile left of "GRAVEYARD"
      call       putChar

      call       delay
      call       clearKeys

      ld         a,$e2                              ; enable display (it is turned off)
      out        (dVDPCommand),a
      ld         a,dVDPReg1                         ; write to VDP register 01
      out        (dVDPCommand),a

menuLoop:
      call       delay
      call       clearKeys

getInput:
-:
       in        a,(dPortJoystick)                  ; get input
       call      delay                              ; delay to avoid keys 'bouncing'

       bit       0,a                                ; joystick up
       jr        z,decreaseLevel
       bit       1,a                                ; joystick down
       jr        z,increaseLevel
       bit       4,a                                ; button 1
       jr        z,startLevel
       bit       5,a                                ; button 2
       jr        z,startLevel

       jr        -                                  ; if none of the above bits are set, read again

decreaseLevel:
       ld        hl,vLevel
       ld        a,(hl)
       CP        $00                                ; if level is already 00 (level 1), then don't decrement further
       jp        z,menuLoop                         ; but go back and get input again
       dec       (hl)
       jp        menuRefresh

increaseLevel:
       ld        hl,vLevel
       ld        a,(hl)
       CP        $03                                ; if level is already 03 (level 4), then don't increment further
       jp        z,menuLoop                         ; but go back and get input again
       inc       (hl)
       jp        menuRefresh

menuRefresh:                                        ; blank all four possible positions of the dot tile


       ld        de,dBlackTile                      ; output a solid black tile

       ld        hl,$3A8A
       call      putChar
       ld        hl,$3B0A
       call      putChar
       ld        hl,$3B8A
       call      putChar
       ld        hl,$3C0A
       call      putChar

;DEBUG       call      delay

       ld        hl,vLevel

       ld        de,$3A8A
       ld        a,(hl)
       CP        $00
       jp        z,+

       ld        de,$3B0A
       CP        $01
       jp        z,+

       ld        de,$3B8A
       CP        $02
       jp        z,+

       ld        de,$3C0A

+:
       ld        h,d
       ld        l,e
       ld        d,dDotTile
       call      putChar
       call      delay


       jp        menuLoop



startLevel:                                             ; proceed to load the chosen level

        ld       a,$a2                                  ; how VDP register 1 was set by the game
        out      (dVDPCommand),a
        ld       a,$81
        out      (dVDPCommand),a

        pop      hl                                      ; prepare to return to original game code
        pop      de
        pop      bc
        pop      af
        ei
        ret                                              ; return to address $032F


; Data ------------------------------------------------------------------------
menuTitle:
        .db $A5 $AA $9E $AA $A9 $A6 $00 $9E
        .db $AA $A8 $AA $9E
menuTitleEnd:

menuitemGraveyard:
        .db $99 $A4 $93 $A8 $AA $9A $93 $A4
        .db $96
menuitemGraveyardEnd:

menuitemUnderworld:
        .db $A7 $A0 $96 $AA $A4 $95 $A1 $A4
        .db $9E $96
menuitemUnderworldEnd:

menuitemNeff:
        .db $A0 $AA $98 $98 $A5 $00 $A2 $93
        .db $9E $93 $A9 $AA
menuitemNeffEnd:

menuitemDis:
        .db $A6 $AB $AA $00 $A9 $AC $A6 $9A
        .db $00 $A1 $98 $00 $96 $AC $A5
menuitemDisEnd:
; -----------------------------------------------------------------------------



; Function: putChar -----------------------------------------------------------
; Writes the char specified in D to the tilemap location in HL
; HL = location on tilemap
; D  = char to put

putChar:
        ld       a, h
        or       $40
        ld       h, a
        ld       a,l
        out     ($bf),a
        ld       a,h
;        nop
;        nop
        out      ($bf),a

        ld       a,d
        out     ($be),a
        ld       a,%00000001
;        nop
;        nop
        out     ($be),a
        ret
;------------------------------------------------------------------------------

; Function: drawMenuItem ------------------------------------------------------
; Writes B bytes of the string pointed to by DE, to the tilemap location in HL
; HL = position on tilemap
; DE = pointer to string
; B  = amount of characters to write

drawMenuItem:
        ld       a,h
        or       $40
        ld       h,a
        ld       a,l
        out     ($bf),a
        ld       a,h
        out     ($bf),a

        ld       h,d
        ld       l,e

-:
        ld       a,(hl)
        inc      hl
        out     ($be),a
        ld       a,%00001001
        out     ($be),a
        dec      b
        jr       nz,-

        ret
;------------------------------------------------------------------------------


; Function: delay -------------------------------------------------------------
; Delays the program flow by looping three NOP's 256 times

delay:
        push     af
        push     bc


        ld       b,$00
-:
        nop
        nop
        nop
        djnz     -                                  ; loop 256 times

        pop      bc
        pop      af
        ret
;------------------------------------------------9------------------------------

clearKeys:                ; halt until no keys are pressed
       push      af
       push      bc
       ld        b, $FF
-:
       in        a,(dPortJoystick)

       cp        $FF
       jr        nz,-
       in        a,(dPortJoystick)

       cp        $FF
       jr        nz,-
       in        a,(dPortJoystick)

       cp        $FF
       jr        nz,-
       in        a,(dPortJoystick)

       cp        $FF
       jr        nz,-
       in        a,(dPortJoystick)

       cp        $FF
       jr        nz,-

       djnz      -
       pop       bc
       pop       af
       ret